/**
	$Id: SignalRequestHandler.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.jobagent.handlers;

import java.net.Socket;

import net.sf.basedb.clients.jobagent.Agent;
import net.sf.basedb.clients.jobagent.AgentSignalReceiver;
import net.sf.basedb.util.jobagent.RequestHandler;

/**
	This is a request handler for the <code>signal</code> commands. 
	It will send signal to running jobs.

	@author nicklas
	@version 2.6
	@base.modified $Date: 2008-09-11 22:05:50 +0200 (Thu, 11 Sep 2008) $
*/
public class SignalRequestHandler
	implements RequestHandler
{

	private final Agent agent;
	private final AgentSignalReceiver signalReceiver;
	
	public SignalRequestHandler(Agent agent)
	{
		this.agent = agent;
		this.signalReceiver = agent.getSignalReceiver();
	}
	
	/*
		From the RequestHandler interface
		-------------------------------------------
	*/
	public String handleCmd(Socket incoming, String cmd)
	{
		signalReceiver.processSignalMessage(cmd);
		String answer = "OK";
		return answer;
	}
	// -------------------------------------------

}
