/*
	$Id: WrappedDataItem.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2005, 2006 Gregory Vincic
	Copyright (C) 2007 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/

package net.sf.basedb.clients.migrate;

import net.sf.basedb.core.data.BasicData;

/**
	 @author Gregory
	 @version 2.0
	 @base.modified $Date: 2008-09-11 22:05:50 +0200 (Thu, 11 Sep 2008) $
*/

public class WrappedDataItem<E extends BasicData>
{
	private int base1Id = 0;
	private E item = null;

	WrappedDataItem(E item, int base1Id)
	{
		this.base1Id = base1Id;
		this.item = item;
	}

	public void setItem(E item)
	{
		this.item = item;
	}

	public E getItem()
	{
		return item;
	}

	public void setBase1Id(int id)
	{
		base1Id = id;
	}

	public int getBase1Id()
	{
		return base1Id;
	}

	public int getId()
	{
		return item.getId();
	}
}
