/*
	$Id: Rows.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.taglib.table;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.TagSupport;

/**
	This tag is a place-holder for {@link Rows &lt;tbl:row&gt;} tags.
	It has no attributes and must be placed inside a {@link Table &lt;tbl:table&gt;}
	tag.

	<p>
	<b>Syntax:</b>
	<pre>
   &lt;tbl:rows&gt;
      &lt;tbl:row ... &gt;
   &lt;/tbl:rows&gt;
</pre>
	<p>
	The <code>&lt;tbl:rows&gt;</code> may contain the following subtags:
	<ul>
	<li>{@link Row &lt;tbl:row&gt;}: Adds a row to the table
	</ul>

	@author Nicklas
	@version 2.0
*/
public class Rows
	extends TagSupport
{

	/**
		
	*/
	private static final long serialVersionUID = 2099882746242865479L;
	private Table table;
	private Data data;

	/*
		Taglib initialization methods
	*/

	/*
		Package methods
	*/
	Table getTable()
	{
		return table;
	}
	Data getData()
	{
		return data;
	}

	/*
		Display methods
	*/
	public int doStartTag()
		throws JspException
	{
		if (!(getParent() instanceof Data)) throw new JspTagException("Tag <tbl:rows> must be inside a <tbl:data> tag");
		data = (Data)getParent();
		table = data.getTable();
		return EVAL_BODY_INCLUDE;
	}

}

