/*
	$Id: InvalidAnnotationException.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**

	@author Nicklas
	@version 2.0
*/
public class InvalidAnnotationException
	extends InvalidDataException
{
	/**
		
	*/
	private static final long serialVersionUID = -3711446965517938282L;
	/**
		Create a new <code>InvalidAnnotationException</code> object.
	*/
	public InvalidAnnotationException()
	{
		super();
	}

	/**
		Create a new <code>InvalidAnnotationException</code> object with the 
		specified <code>message</code>.

		@param message The message to throw with the exception
	*/
	public InvalidAnnotationException(String message)
	{
		super(message);
	}
	/**
		Create a new <code>InvalidAnnotationException</code> object when
		the annotation type cannot be used for the specified item type.
	 	@param annotationType The annotation type used to annotate. 
	 	@param itemType Kind of item that couldn't be annotated.
	*/
	public InvalidAnnotationException(AnnotationType annotationType, Item itemType)
	{
		super("The annotation type "+annotationType+" cannot be used for "+itemType);
	}

}




