/*
	$Id: InvalidDataException.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005, 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Exceptions of this type are thrown when invalid data is encountered.
	The real exception thrown is usually of a subclass to this class.

	@author Nicklas
	@version 2.0
*/
public class InvalidDataException
	extends BaseException
{
	/**
		
	*/
	private static final long serialVersionUID = -7183580873652712069L;

	/**
		Create a new <code>InvalidDataException</code> object.
	*/
	public InvalidDataException()
	{
		super();
	}

	/**
		Create a new <code>InvalidDataException</code> object.
	 	@param cause Throwable object that caused this exception. 
	*/
	public InvalidDataException(Throwable cause)
	{
		super(cause);
	}

	/**
		Create a new <code>InvalidDataException</code> object with the 
		specified <code>message</code>.

		@param message The message to throw with the exception
	*/
	public InvalidDataException(String message)
	{
		super(message);
	}
	
	/**
		Create a new <code>InvalidDataException</code> object with the 
		specified <code>message</code>.
	
		@param message The message to throw with the exception
	 	@param cause Throwable object that caused this exception.
	*/
	public InvalidDataException(String message, Throwable cause)
	{
		super(message, cause);
	}

}




