/*
	$Id: AnnotatedData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This class extends the {@link CommonData} class and implements the
	{@link AnnotatableData} interface. Ie. by extending this class a data item 
	becomes annotatable.

	@author Nicklas
	@version 2.0
	@see AnnotatableData
	@see net.sf.basedb.core.AnnotatedItem
	@see <a href="../../../../../../html/developerdoc/api/data_api.annotations.html">Annotation overview</a>
*/
public abstract class AnnotatedData
	extends CommonData
	implements AnnotatableData
{

	public AnnotatedData()
	{}
	
	/*
		From the AnnotatableData interface
		-------------------------------------------
	*/
	private AnnotationSetData annotationSet;
	public AnnotationSetData getAnnotationSet()
	{
		return annotationSet;
	}
	public void setAnnotationSet(AnnotationSetData annotationSet)
	{
		this.annotationSet = annotationSet;
	}
	// -------------------------------------------

}
