/*
	$Id: JepFunction.java 4515 2008-09-11 20:08:14Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.jep;

import org.nfunk.jep.function.PostfixMathCommandI;
import org.nfunk.jep.JEP;

/**
	This interface should be implemented by objects that can
	perform some kind of calculation for a {@link JEP} expression. This interface
	is just the addition of a name to the {@link PostfixMathCommandI}
	interface defined by JEP.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-11 22:08:14 +0200 (Thu, 11 Sep 2008) $
	@see Jep#newJep(String, JepFunction[])
	@see Jep
*/
public interface JepFunction
	extends PostfixMathCommandI
{

	/**
		Get the name of this function. It is used when registering the
		function with a {@link JEP} parser.
		@see JEP#addFunction(String, PostfixMathCommandI)
	*/
	public String getFunctionName();

}
