/*
	$Id: JarPlugin.java 4514 2008-09-11 20:07:12Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
 
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
import net.sf.basedb.core.ProgressReporter;
import net.sf.basedb.core.plugin.About;
import net.sf.basedb.core.plugin.AbstractPlugin;
import net.sf.basedb.core.plugin.Request;
import net.sf.basedb.core.plugin.Response;

/**
 	Just a simple test plugin that is placed in a JAR file.
 	
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-11 22:07:12 +0200 (Thu, 11 Sep 2008) $
*/
public class JarPlugin 
	extends AbstractPlugin
	implements JarPluginInterface
{

	public MainType getMainType()
	{
		return JarPluginType.getMainType();
	}

	public About getAbout()
	{
		return JarPluginAbout.getAbout();
	}
	public boolean supportsConfigurations()
	{
		return false;
	}
	public boolean requiresConfiguration()
	{
		return false;
	}

	/**
		Just print some info to the ProgressReporter for the Request COMMAND_EXECUTE.
	*/
	public void run(Request request, Response response, ProgressReporter progress)
	{
		response.setDone("Ok");
	}
	
	public void uploadToRepository(String repositoryPath)
	{}


}
