<%-- $Id: edit_quota.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private String getQuotaInput(Quota quota, QuotaType type, Location location)
{
	if (location == Location.SECONDARY && !type.hasSecondaryLocation()) return "N/A";
	long bytes = quota == null ? Quota.UNDEFINED : quota.getQuotaValue(type, location);
	String fBytes = "";
	String clazz = "text";
	if (bytes == Quota.UNLIMITED)
	{
		fBytes = "unlimited";
		clazz += " disabled";
	}
	else if (bytes >= 0)
	{
		fBytes = Values.formatBytes(bytes);
	}
	boolean required = type.getId() == SystemItems.getId(QuotaType.TOTAL) && location == Location.PRIMARY;
	if (required) clazz += " required";

	StringBuilder sb = new StringBuilder();
	sb.append("<input type=\"text\" class=\"").append(clazz).append("\"");
	sb.append(" size=\"16\" maxlength=\"16\"");
	sb.append(" name=\"").append(location.name()).append(type.getId()).append("\"");
	sb.append(" value=\"").append(fBytes).append("\"");
	sb.append(">");
	sb.append("<input type=\"checkbox\" value=\"1\"");
	sb.append(" name=\"unlimited_").append(location.name()).append(type.getId()).append("\"");
	sb.append(bytes==Quota.UNLIMITED ? " checked" : "");
	sb.append(" onclick=\"setQuotaValue('").append(location.name()).append(type.getId()).append("', this.checked)\"");
	sb.append(" title=\"Unlimited quota\">\n");
	return sb.toString();
}
%>
<%
final Item itemType = Item.QUOTA;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Quota quota = null;

	if (itemId == 0)
	{
		title = "Create quota";
		cc.removeObject("item");
	}
	else
	{
		quota = Quota.getById(dc, itemId);
		cc.setObject("item", quota);
		title = "Edit quota -- " + HTML.encodeTags(quota.getName());
	}
	if (quota != null && !quota.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final QuotaType total = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));

	// Query to retrieve quota types
	final ItemQuery<QuotaType> quotaTypeQuery = QuotaType.getQuery();
	quotaTypeQuery.order(Orders.asc(Hql.property("id")));
	quotaTypeQuery.restrict(
		Restrictions.neq(
			Hql.property("id"), 
			Hql.entity(total)
		)
	);
	quotaTypeQuery.setCacheResult(true);

	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Quota" tab
		function validateQuota()
		{
			var frm = document.forms['quota'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name for the quota.");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Quota values" tab
		function validateValues()
		{
			var frm = document.forms['quota'];
			if (Main.trimString(frm.<%=Location.PRIMARY.name()+total.getId()%>.value) == '')
			{
				TabControl.setActiveTab('settings', 'values');
				alert('You must enter a total primary quota');
				frm.<%=Location.PRIMARY.name()+total.getId()%>.focus();
				return false;
			}
			return true;
		}
		
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['quota'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (!validateValues()) return;
				frm.submit();
			}
		}
		
		function setQuotaValue(name, unlimitedChecked)
		{
			var frm = document.forms['quota'];;
			var quota = frm[name];
			if (unlimitedChecked)
			{
				Main.addClass(quota, 'disabled');
				quota.disabled = true;
				quota.oldValue = quota.value;
				quota.value = 'unlimited';
			}
			else
			{
				Main.removeClass(quota, 'disabled');
				quota.disabled = false;
				quota.value = quota.oldValue ? quota.oldValue : '';
			}
		}

		function init()
		{
			<%
			if (quota == null)
			{
				%>
				var frm = document.forms['quota'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="quota" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*320)+"px;"%>" 
			position="bottom" remember="<%=quota != null%>">
		<t:tab id="info" title="Quota" validate="validateQuota()" helpid="quota.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(quota == null ? Values.getString(cc.getPropertyValue("name"), "New quota") : quota.getName())%>" 
					size="40" maxlength="<%=Quota.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(quota == null ? cc.getPropertyValue("description") : quota.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'quota', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="values" title="Quota values" tooltip="Specify maximum disk usage values" 
			validate="validateValues()" helpid="quota.edit.values">
			<table class="form" width="100%">
			<tr>
				<td></td>
				<td><b>Primary location</b></td>
				<td><b>Secondary location</b></td>
			</tr>
			<tr>
				<td class="prompt">Total quota</td>
				<td><%=getQuotaInput(quota, total, Location.PRIMARY)%></td>
				<td><%=getQuotaInput(quota, total, Location.SECONDARY)%></td>
			</tr>
			<tr>
				<td colspan="3" style="border-top: 1px solid #cccccc"></td>
			</tr>
			<%
			ItemResultList<QuotaType> quotaTypes = quotaTypeQuery.list(dc);
			for (QuotaType current : quotaTypes)
			{
				%>
				<tr>
				<td><%=HTML.encodeTags(current.getName())%></td>
				<td><%=getQuotaInput(quota, current, Location.PRIMARY)%></td>
				<td><%=getQuotaInput(quota, current, Location.SECONDARY)%></td>
				</tr>
				<%
			}
			%>
			<tr>
				<td colspan="3">
					<div align="right">&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
						<br>
						The individual quota values doesn't have to sum up to the total value.
						The most restrictive value is always used.
						You can use the following units (case-insensitive):
						<ul>
						<li><b>Gb</b> or <b>G</b> for gigabyte values (<code>1.5 Gb</code>)
						<li><b>Mb</b> or <b>M</b> for megabyte values (<code>10M</code>)
						<li><b>Kb</b> or <b>K</b> for kilobyte values (<code>800k</code>)
						<li><b>bytes</b> or <b>b</b> for byte values (<code>50 bytes</code>)
						</ul>
				</td>
			</tr>
			</table>
			
		</t:tab>
		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
