<%-- $Id:select_files.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	
--%>
<%@ page
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.TreeSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final int platformId = Values.getInt(request.getParameter("platform_id"), -1);
final int variantId = Values.getInt(request.getParameter("variant_id"), -1);
final ItemContext cc = sc.getCurrentContext(itemType);

final DbControl dc = sc.newDbControl();
try
{

	// Get the current item; null if we are editing a new item
	final FileStoreEnabled item = itemId == 0 ? null : (FileStoreEnabled)itemType.getById(dc, itemId);
	FileSet fileSet = null;
	if (item != null && item.hasFileSet())
	{
		fileSet = item.getFileSet();
	}

	// Get the current platform/variant 
	// -- if not submitted in URL use values from current item
	PlatformVariant variant = null;
	Platform platform = null;
	boolean deniedPlatform = false;
	try
	{
		if (variantId > 0)
		{
			variant = PlatformVariant.getById(dc, variantId);
			platform = variant.getPlatform();
		}
		else if (platformId > 0)
		{
			platform = Platform.getById(dc, platformId);
		}
		else if (item != null)
		{
			variant = item.getVariant();
			platform = item.getPlatform();
		}
	}
	catch (PermissionDeniedException ex)
	{
		deniedPlatform = true;	
	}
	
	// Query to load data file types for specific itemType/platform/variant
	final ItemQuery<DataFileType> fileTypeQuery = 
		Base.getDataFileTypes(itemType, item, platform, variant);
	List<DataFileType> fileTypes = fileTypeQuery.list(dc);
	
	
	String title = "Select data files for " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
			(item == null ? " new item" : item.toString())));

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	final StringBuilder sb = new StringBuilder();
	List<File> recentFiles = null;
	
	%>
<base:page type="popup" title="<%=title%>">
	<base:head scripts="" styles="parameters.css">
	
	<script language="JavaScript">
	function init()
	{
	}
	var lastFileInputName;
	function browseOnClick(inputName, extension)
	{
		var frm = document.forms['datafiles'];
		var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
		if (extension)
		{
			url += '&filter:STRING:name='+escape('%.' + extension);
		}
		else
		{
			url += '&filter:STRING:name=';
		}
		lastFileInputName = inputName;
		Main.openPopup(url, 'SelectFile', 1000, 700);
	}
	function setFileCallback(fileId, path)
	{
		var frm = document.forms['datafiles'];
		frm[lastFileInputName].value = path;
		fileOnChange(lastFileInputName);
	}
	function fileOnChange(inputName)
	{
		var frm = document.forms['datafiles'];
		if (frm[inputName].value != '')
		{
			frm['datafiles.validate'].checked = true;
			frm['datafiles.metadata'].checked = true;
		}
	}
	function recentOnChange(inputName)
	{
		var frm = document.forms['datafiles'];
		var recentInput = frm['recent.'+inputName];
		if (recentInput.selectedIndex > 0)
		{
			var option = recentInput[recentInput.selectedIndex];
			var path = option.value == '' ? '' : option.text;
			if (frm[inputName].value != path)
			{
				frm[inputName].value = path;
				fileOnChange(inputName);
			}
			recentInput.selectedIndex = 0;
		}
	}
	</script>
	</base:head>
	
	<base:body onload="init()" style="background: #E0E0E0;">

		<form name="datafiles">
		<%
		if (fileTypes.size() == 0)
		{
			%>
			<div class="error">
				The <%=platform == null ? "" : "'" + HTML.encodeTags(platform.getName()) + "'" %>
				platform doesn't define any file types for <%=itemType.toString() %>
				items.
			</div>
			<%
		}
		else if (deniedPlatform)
		{
			%>
			<div class="error">Denied</div>
			<%
		}
		else
		{
			%>
			<table class="form" cellspacing="2" border="0" cellpadding="0" width="100%">
			<%
			boolean hasNonPlatformFiles = false;
			for (DataFileType dft : fileTypes)
			{
				PlatformFileType pft = platform == null ?
					null : platform.getFileType(dft, variant);
				// If file type is not registered with a variant, also check if it is inherited from platform
				if (pft == null && variant != null) pft = platform.getFileType(dft, null);
				boolean isPartOfPlatform = pft != null;
				boolean isRequired = pft == null ? false : pft.isRequired();
				FileSetMember member = fileSet == null || !fileSet.hasMember(dft) ?
					null : fileSet.getMember(dft);
				File file = null;
				boolean deniedFile = false;
				String extension = dft.getExtension();
				if (member != null)
				{
					try
					{
						file = member.getFile();
					}
					catch (PermissionDeniedException ex)
					{
						deniedFile = true;
					}
				}
				
				String path = "";
				if (file != null)
				{
					path = file.getPath().toString();
				}
				else if (deniedFile || deniedPlatform)
				{
					path = "- denied -";
				}
				String inputName= "datafile."+dft.getId();
				recentFiles = (List<File>)cc.getRecent(dc, Item.FILE, dft.getExternalId());
				%>
				<tr>
					<td class="prompt"><%=HTML.encodeTags(dft.getName())%>
					<%
					if (!isPartOfPlatform && !deniedPlatform)
					{
						hasNonPlatformFiles = true;
						%>
						<base:icon image="warning.gif" tooltip="This file is not part of the platform" />
						<%
					}
					%>
					</td>
					<td>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td>			
								<input <%=isRequired ? requiredClazz : clazz%> type="text" 
								name="<%=inputName%>" value="<%=HTML.encodeTags(path)%>"
								size="50" title="<%=HTML.encodeTags(dft.getDescription())%>"
								<%=deniedFile || deniedPlatform ? "disabled" : "" %>
								onchange="fileOnChange('<%=inputName%>')">&nbsp;
							</td>
							<td><base:button 
									title="Browse&hellip;"
									onclick="<%="browseOnClick('"+inputName+"', '" + HTML.javaScriptEncode(extension) + "')"%>"
									disabled="<%=deniedFile || deniedPlatform %>"
									/>
							</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td align="right"></td>
					<td>
					<%
					if (recentFiles != null && recentFiles.size() > 0)
					{
						%>
						<select name="recent.<%=inputName%>" onchange="recentOnChange('<%=inputName%>')">
						<option value="">- recently used -
						<option value="">- clear -
						<%
						for (File recent : recentFiles)
						{
							%>
							<option value="<%=recent.getId()%>"><%=HTML.encodeTags(recent.getPath().toString())%>
							<%
						}
						%>
						</select>
						<%
					}
					%>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Validate</td>
				<td><input type="checkbox" value="1" name="datafiles.validate"></td>
			</tr>
			<tr>
				<td class="prompt">Extract metadata</td>
				<td><input type="checkbox" value="1" name="datafiles.metadata"></td>
			</tr>
			</table>
			<%
			if (platform != null && hasNonPlatformFiles)
			{
				%>
				<div align="right">
				<base:icon image="warning.gif" /> 
				= The file type is not part of the <i><%=HTML.encodeTags(platform.getName())%></i> platform
				</div>
				<%
			}
			%>
			<%
		}
		%>

		</form>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
